hdu 4044 GeoDefense(DP-树形DP)

GeoDefense

Time Limit: 12000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 686    Accepted Submission(s): 275


Problem Description
Tower defense is a kind of real-time strategy computer games. The goal of tower defense games is to try to stop enemies from reaching your bases by building towers which shoot at them as they pass. 

The choice and positioning of the towers is the essential strategy of the game. Many games, such as Flash Element Tower Defense, feature enemies that run through a "maze", which allows the player to strategically place towers for optimal effectiveness. However, some versions of the genre force the user to create the maze out of their own towers, such as Desktop Tower Defense. Some versions are a hybrid of these two types, with preset paths that can be modified to some extent by tower placement, or towers that can be modified by path placement.

geoDefense is a Thinking Man’s Action Tower Defense. It has become one of "PC World's 10 iPhone Games You CANNOT Live Without". Using exciting vectorized graphics, this highly kinetic game brings a whole new dimension to the defense genre. Devastate creeps with blasters, lasers and missiles and watch their energy debris swirl through the gravity wells of your vortex towers.

There is a geoDefense maze of n points numbered from 1 and connected by passageways. There are at least two dead ends among these n points, and there is always one and only one path between any pair of points. Point 1 is a dead end, and it’s the base of enemies, and all the other dead ends are your bases.

To prevent the enemy reaching your bases, you have to construct towers to attack the enemy. You can build tower on any point and you can only build one tower on one point. A tower can only shot the enemy when it passes the tower. You are given ki choices to build tower on point i, and each choice is given in the format of (price, power) which means that you can build a tower with attack power value equals power in the cost of price. You can also build nothing on a point so it will not cost your money. A tower will reduce the enemy’s HP by its attack power. When the HP is less or equal to zero, the enemy dies immediately. 

The base of enemies will release only one enemy. It moves very fast that you cannot do anything such as building towers while it is running. It runs all the way until it dies or reaches one of your bases. However, you cannot predict the route it will go through. To win the game, you must kill the enemy before it reaches your bases. You have to strategically place towers for optimal effectiveness so that the fortifications are steady enough to protect the bold and powerful enemy with high HP. You are troubling your head on figuring out the highest HP of the enemy you are able to kill on the way certainly. You have money m when the game begins.
Please note that the towers build in the enemy’s base or your bases are all effective and if the enemy is shot to death in your bases, you still win.
 

Input
The input consists of several test cases. The first line is an integer T (1 <= T <= 20), which shows the number of the cases.
For each test case, the first line contains only one integer n (2 <= n <= 1000) meaning the number of points. 
The following n-1 lines describe the passageways. Each line contains two integers u and v, which are the endpoints of a passageway. 
The following line contains only one integer m (1 <= m <= 200) meaning the amount of your money when the game begins. 
Then n lines follow. The ith line describes the construction choices of the ith point. It starts with an integer ki (0 <= ki <= 50) and ki is followed by ki pairs of integers separated by spaces. The jth pair is (pricei,j, poweri,j), 0 <= pricei,j <= 200, 0 <= poweri,j <= 50000. ki being zero means that you can’t build a tower on the ith point. 
 

Output
For each test case, output a line containing the highest HP value of your enemy that you can deal with. It means that if your enemy’s HP is larger than that highest value, you can’t guarantee your victory.
 

Sample Input
  
  
2 2 1 2 30 3 10 20 20 40 30 50 3 10 30 20 40 30 45 4 2 1 3 1 1 4 60 3 10 20 20 40 30 50 3 10 30 20 40 30 45 3 10 30 20 40 30 35 3 10 30 20 40 30 35
 

Sample Output
  
  
70 80
 
题意:给一棵树,树根一定是1,敌人在1位置,每个叶子节点是你的基地,每个节点(包括1节点和你的基地)可以建一个防御塔,每个节点有多种防御塔供你选择,告诉你每种防御塔的价钱和防御能力。你现在有m这么多钱,你可以所有节点上建塔,每个节点只能建一个或不建塔。敌人很聪明,它会去摧毁防御最弱的路线(路线上所有点的防御能力之和)的基地。问你防御最弱的路线防御能力的最大值可以是多少?

解题思路:题目给了一棵树,第一反应就是树形DP。
dp[u][i],表示以u为根的这棵子树,刚好花了i这么多钱,防御最弱路线的最大值是多少。
请看下图,现在,我们假设儿子的结果已经都求出来了,那如何推出父亲节点呢?

首先,假设父亲节点不建防御塔,设tdp[m]表示以f为根的子树,花了刚好m这么多钱,防御最弱路线的最大值,那么:
tdp[m] = min(dp[s1][m1] , dp[s2][m2] , dp[s3][m3] , dp[s4][m4]);
其中m1+m2+m3+m4 = m。这个时候,我们发现,这还得排列组合一下,然后取个最大才对:
tdp[m] = max(  排列组合m1...m4   min(dp[s1][m1] , dp[s2][m2] , dp[s3][m3] , dp[s4][m4]));
正常我们可以用暴力去枚举m1...m4,然后排列组合一下,但在这里并不合适,会超时。
那么,我们多开一维数组,tdp[n][m]表示前n个儿子用了m这么多钱,防御最弱路线的最大值是多少,初始化为INF。
递推公式为:

若tdp[i][m1+m2] == INF,tdp[i][m1+m2] = min(tdp[i-1][m1] , dp[si][m2]);
否则,tdp[i][m1+m2] = max(tdp[i][m1+m2] , min(tdp[i-1][m1] , dp[si][m2]));

把tdp[n][m]求完之后,我们就知道节点f不建防御塔时,用了m这么多钱,防御最弱路线的最大值。
而每个节点只能建一个防御塔,我们只要枚举一下建哪个防御塔最优就行了,设ta[m]表示用m这么多钱建塔,该塔的防御值。
初始化dp[u][m]为INF,那么:

若dp[u][m1+m2] == INF ,dp[u][m1+m2] = tdp[n][m1]+ta[m2];
否则,dp[u][m1+m2] = max(dp[u][m1+m2] = tdp[n][m1]+ta[m2]);

最后,答案就是max(dp[1][m])。

坑点:一个节点不同防御塔的价格有可能相同。
1 2 
0
2 0 10 0 20 
1 0 10

#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

#define INF 1000000000
const int maxn = 1010;
const int maxm = 210;
vector<int> mp[maxn] , power[maxn] , price[maxn];
int dp[maxn][maxm] , tdp[maxn][maxn][maxm];
int n , m;

void initial(){
    for(int i = 0; i < maxn; i++){
        mp[i].clear();
        power[i].clear();
        price[i].clear();
        for(int j = 0; j < maxm; j++) dp[i][j] = INF;
    }
}

void readcase(){
    scanf("%d" , &n);
    int u , v;
    for(int i = 0; i < n-1; i++){
        scanf("%d%d" , &u , &v);
        mp[u].push_back(v);
        mp[v].push_back(u);
    }
    scanf("%d" , &m);
    int k , pri , pow;
    for(int i = 1; i <= n; i++){
        scanf("%d" , &k);
        for(int j = 0; j < k; j++){
            scanf("%d%d" , &pri , &pow);
            if(pri <= m) price[i].push_back(pri) , power[i].push_back(pow);
        }
    }
}

void DP(int u , int f){
    for(int i = 0; i <= mp[u].size()+1; i++){
        for(int j = 0; j <= m; j++) tdp[u][i][j] = INF;
    }
    int sid = 1;
    for(int i = 0; i < mp[u].size(); i++){
        int son = mp[u][i];
        if(son != f){
            DP(son , u);
            for(int k = m; k >= 0; k--){
                if(tdp[u][sid-1][k] == INF && !(sid == 1 && k == 0)) continue;
                for(int j = m-k; j >= 0; j--){
                    if(dp[son][j] == INF) continue;
                    if(tdp[u][sid][j+k] == INF) tdp[u][sid][j+k] = min(tdp[u][sid-1][k] , dp[son][j]);
                    else tdp[u][sid][j+k] = max(tdp[u][sid][j+k] , min(tdp[u][sid-1][k] , dp[son][j]));
                }
            }
            sid++;
        }
    }
    tdp[u][0][0] = 0;
    for(int i = 0; i < price[u].size(); i++){
        if(tdp[u][0][price[u][i]] != INF) tdp[u][0][price[u][i]] = max(tdp[u][0][price[u][i]] , power[u][i]);
        else tdp[u][0][price[u][i]] = power[u][i];
    }
    if(!(mp[u].size() == 1 && mp[u][0] == f)){
        for(int k = m; k >= 0; k--){
            if(tdp[u][0][k] == INF) continue;
            for(int j = m-k; j >= 0; j--){
                if(tdp[u][sid-1][j] == INF) continue;
                if(tdp[u][sid][j+k] == INF) tdp[u][sid][j+k] = tdp[u][0][k]+tdp[u][sid-1][j];
                else tdp[u][sid][j+k] = max(tdp[u][sid][j+k] , tdp[u][0][k]+tdp[u][sid-1][j]);
            }
        }
        sid++;
    }
    for(int i = 0; i <= m; i++){
        if(tdp[u][sid-1][i] == INF) continue;
        dp[u][i] = tdp[u][sid-1][i];
    }
}

void computing(){
    DP(1 , 0);
    int Max =0;
    for(int i = 0; i <= m; i++){
        if(dp[1][i] == INF) continue;
        Max = max(dp[1][i] , Max);
    }
    printf("%d\n" , Max);
}

int main(){
    int T;
    scanf("%d", &T);
    while(T--){
        initial();
        readcase();
        computing();
    }
    return 0;
}


  • 1
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
### 回答1: hdu 2829 Lawrence 斜率优化dp 这道题是一道经典的斜率优化dp题目,需要用到单调队列的思想。 题目大意是给定一个序列a,求出一个序列b,使得b[i]表示a[1]~a[i]中的最小值,且满足b[i] = min{b[j] + (i-j)*k},其中k为给定的常数。 我们可以将上式拆开,得到b[i] = min{b[j] - j*k} + i*k,即b[i] = i*k + min{b[j] - j*k},这个式子就是斜率优化dp的形式。 我们可以用单调队列来维护min{b[j] - j*k},具体思路如下: 1. 首先将第一个元素加入队列中。 2. 从第二个元素开始,我们需要将当前元素加入队列中,并且需要维护队列的单调性。 3. 维护单调性的方法是,我们从队列的末尾开始,将队列中所有大于当前元素的元素弹出,直到队列为空或者队列中最后一个元素小于当前元素为止。 4. 弹出元素的同时,我们需要计算它们对应的斜率,即(b[j]-j*k)/(j-i),并将这些斜率与当前元素的斜率比较,如果当前元素的斜率更小,则将当前元素加入队列中。 5. 最后队列中的第一个元素就是min{b[j] - j*k},我们将它加上i*k就得到了b[i]的值。 6. 重复以上步骤直到处理完所有元素。 具体实现可以参考下面的代码: ### 回答2: HDU 2829 Lawrence 斜率优化 DP 是一道经典的斜率优化 DP 题目,其思想是通过维护一个下凸包来优化 DP 算法。下面我们来具体分析一下这道题目。 首先,让我们看一下该题目的描述。题目给定一些木棒,要求我们将这些木棒割成一些给定长度,且要求每种长度的木棒的数量都是一样的,求最小的割枝次数。这是一个典型的背包问题,而且在此基础上还要求每种长度的木棒的数量相同,这就需要我们在状态设计上走一些弯路。 我们来看一下状态的定义。定义 $dp[i][j]$ 表示前 $i$ 个木棒中正好能割出 $j$ 根长度为 $c_i$ 的木棒的最小割枝次数。对于每个 $dp[i][j]$,我们可以分类讨论: 1. 不选当前的木棒,即 $dp[i][j]=dp[i-1][j]$; 2. 选当前的木棒,即 $dp[i][j-k]=dp[i-1][j-k]+k$,其中 $k$ 是 $j/c_i$ 的整数部分。 现在问题再次转化为我们需要在满足等量限制的情况下,求最小的割枝次数。可以看出,这是一个依赖于 $c_i$ 的限制。于是,我们可以通过斜率优化 DP 来解决这个问题。 我们来具体分析一下斜率优化 DP 算法的思路。我们首先来看一下动态规划的状态转移方程 $dp[i][j]=\min\{dp[i-1][k]+x_k(i,j)\}$。可以发现,$dp[i][j]$ 的最小值只与 $dp[i-1][k]$ 和 $x_k(i,j)$ 有关。其中,$x_k(i,j)$ 表示斜率,其值为 $dp[i-1][k]-k\times c_i+j\times c_i$。 接下来,我们需要维护一个下凸包,并通过斜率进行优化。我们具体分析一下该过程。假设我们当前要计算 $dp[i][j]$。首先,我们需要找到当前点 $(i,j)$ 在凸包上的位置,即斜率最小值的位置。然后,我们根据该位置的斜率计算 $dp[i][j]$ 的值。接下来,我们需要将当前点 $(i,j)$ 加入到下凸包上。 我们在加入点的时候需要注意几点。首先,我们需要将凸包中所有斜率比当前点小的点移除,直到该点能够加入到凸包中为止。其次,我们需要判断该点是否能够加入到凸包中。如果不能加入到凸包中,则直接舍弃。最后,我们需要保证凸包中斜率是单调递增的,这就需要在加入新的点之后进行上一步操作。 以上就是该题目的解题思路。需要注意的是,斜率优化 DP 算法并不是万能的,其使用情况需要根据具体的问题情况来确定。同时,该算法中需要维护一个下凸包,可能会增加一些算法的复杂度,建议和常规 DP 算法进行对比,选择最优的算法进行解题。 ### 回答3: 斜率优化DP是一种动态规划优化算法,其主要思路是通过对状态转移方程进行变形,提高算法的时间复杂度。HDU2829 Lawrence问题可以用斜率优化DP解决。 首先,我们需要了解原问题的含义。问题描述如下:有$n$个人在数轴上,第$i$个人的位置为$A_i$,每个人可以携带一定大小的行李,第$i$个人的行李重量为$B_i$,但是每个人只能帮助没有他们重量大的人搬行李。若第$i$个人搬运了第$j$个人的行李,那么第$i$个人会累加$C_{i,j}=\left|A_i-A_j\right|\cdot B_j$的体力消耗。求$m$个人帮助每个人搬运行李的最小体力消耗。 我们可以通过斜率优化DP解决这个问题。记$f_i$为到前$i$个人的最小体力消耗,那么状态转移方程为: $$f_i=\min_{j<i}\{f_j+abs(A_i-A_j)\cdot B_i\}$$ 如果直接使用该方程,时间复杂度为$O(n^2)$,如果$n=10^4$,则需要计算$10^8$次,运算时间极长。斜率优化DP通过一些数学推导将方程变形,将时间复杂度降低到$O(n)$,大大缩短了计算时间。 通过斜率优化DP的推导式子,我们可以得到转移方程为: $$f_i=\min_{j<i}\{f_j+slope(j,i)\}$$ 其中,$slope(j,i)$表示直线$j-i$的斜率。我们可以通过如下方式来求解$slope(j,i)$: $$slope(j,i)=\frac{f_i-f_j}{A_i-A_j}-B_i-B_j$$ 如果$slope(j,i)\leq slope(j,k)$,那么$j$一定不是最优,可以直接舍去,降低计算时间。该算法的时间复杂度为$O(n)$。 综上所述,斜率优化DP是一种动态规划优化算法,可以大大缩短计算时间。在处理类似HDU2829 Lawrence问题的时候,斜率优化DP可以很好地解决问题。

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值